
#if !defined(_Little)
#define _Little

#include <fstream>
using namespace std; 
#include <iostream>
using namespace std; 
#include <iomanip>
using namespace std; 

#include "Qube.h"
#include "Plane.h"


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyLittleSubTask - 

class MyLittleSubTask {
private:
	MyQube* pQube;	// kein Destructor!
	int nDim;		//    ,  .   pQube
	MyPlane Plane;	//    ( ) - 
					//     .  1  (   )
	bool* No;		//    -  ,      2;
					//   Yes   -       
					// (      Plane,   2)
	/*  Cost  MyQube;      ;
	       ;  -    " "
	int* Cost;		// ""  ;  ,  ;
					//  -   (  1),   ( !)
	*/
	int nScore;		// ""   ,  ,  ; 
					//    - " Yes  No"
public:
	MyLittleSubTask (MyQube* pQube);				//     
	MyLittleSubTask (MyQube* pQube, int mPoint);	//    
	MyLittleSubTask (MyLittleSubTask& copy);
	virtual ~MyLittleSubTask ();
private:
	void Init (MyQube* pQube);			// 1   - . 
	void InitMemory ();					// 2   - . 
	void InitPoint (int mPoint);		// 3   - . 
	//void MakeCostStart ();				//     
public:
	int GetScore ()  { return nScore; }
	int ExtandRandom ();	
		//    Plane   (   ); 
		//     ;    ,   -1;
		//   MyQube::ExtandRandom() - ..   No
	//int ExtandBest ();	//    Plane   
							// (  Cost);     ;
	int ExtandGreedy ();
private:
	int ExtandGreedy2 ();	//     
	int ExtandGreedy3 ();	//     
public:
	void AddYes (int nom)  { Plane.SetBoth(nom); nScore += 3; }
	void AddNo  (int nom)  { No[nom] = true; nScore--; }
	MyLittleSubTask* MakeRight ();
		//   ,    ;
		//  NULL -    , ..   ;
		//        :
	MyPlane& GetPlane ()   { return Plane; }
	friend ostream& operator<< (ostream& os, MyLittleSubTask& mlst);
};


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyArrayLittleSubTask - 

class MyArrayLittleSubTask : public CPtrArray {	// of MyLittleSubTask*
public:
	MyArrayLittleSubTask () : CPtrArray() {}
	virtual ~MyArrayLittleSubTask ();
	MyLittleSubTask* MyGet (int n) { return (MyLittleSubTask*)GetAt(n); }
	void MyAdd (MyLittleSubTask* pSTAdd); 
	MyLittleSubTask* ExtractFirst ();	//  ;  NULL,   
	friend ostream& operator<< (ostream& os, MyArrayLittleSubTask& arrsubtask);
};

// bool operator< (MyLittleSubTask& mlst1, MyLittleSubTask& mlst2);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyLittleTask - 

class MyLittleTask : public MyArrayLittleSubTask {
private:
	int nDim;
	MyQube* pQube;				// kein Destructor!
	MyArrayPlane* pArrPlane;   	// kein Destructor!
	MyArrayPlane16* pArrPlane16;// Destructor!!!
public:
	// c :   
	// MyLittleTask (MyQube* pQube, MyArrayPlane* pArrPlane);
	//       -  ; 
	//  999999 -         
	MyLittleTask (MyQube* pQube, MyArrayPlane* pArrPlane, int kolSubTasks=999999);
	virtual ~MyLittleTask () { delete pArrPlane16; }
	int Step ();
		//    ,     ;
		//    -      ;
		// :	0 - ,  ,    *pArrPlane;
		//			1 -   ,   *pArrPlane    ;
		//			2 -  ;
		//			3 -    ("")
		//			4 -    
	friend ostream& operator<< (ostream& os, MyLittleTask& littletask);
	void Run16 ();	//  ""    16
};


#endif
