
#if !defined(_Plane)
#define _Plane

#include <fstream>
using namespace std; 
#include <iostream>
using namespace std; 
#include <iomanip>
using namespace std; 



const int maxDim = 32;



//      Cost,
//        1   



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyPlane - 

class MyPlane {
private:
	int nDim;
	int nDimPlane;
	unsigned char* Array;
		//     2  -   : 
		// 0,1 -   ,
		// 2 -    
public:
	MyPlane () {}
		//  ; ,     
	MyPlane (int nDim, int mPoint) { Init(nDim,mPoint); }
		//      -  nDimPlane  1;
	MyPlane (int nDim);	
		//   -    nDimPlane  
	MyPlane (MyPlane& copy);
	virtual ~MyPlane ();
	void Init (int nDim, int mPoint);
		//    (   ), 
		//           
private:
	void InitMemory (int nDim);
public:
	unsigned char Get (int nom)  { return Array[nom]; }
	unsigned char operator[] (int nom) { return Array[nom]; }
		//     !!    -  
	bool ExistsPoint (int mPoint);
		//    "m"       int
		// ..,    ., .  -  ;
		// , ,    0  1 -  2
	void SetBoth (int nom);	//   nom    
	friend bool operator== (MyPlane& plane1, MyPlane& plane2);	
		//  
	friend bool operator<= (MyPlane& plane1, MyPlane& plane2);
		// 
	friend bool operator< (MyPlane& plane1, MyPlane& plane2);
		//   ,   -    
	friend istream& operator>> (istream& is, MyPlane& plane);
		//  !     
	friend ostream& operator<< (ostream& os, MyPlane& plane);
//        ;
//         -  ?   ...
// NB:     ! (  .  -   . ):
//        
// (, p    mPoint) -
//   .      -
//  ,   ?
//    ,   -   ,
// "        "
private:
	int nCurCoord;	//   
	bool* CurArray;	//    
public:
	void InitSearch ();	// "  "
	int MakeNext ();	//    "    m";
						//  -1 -    
};



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyArrayPlane - 

class MyArrayPlane : public CPtrArray {	// of MyPlane*
	//     - ..     
public:
	MyArrayPlane () : CPtrArray() {}
	virtual ~MyArrayPlane ();
	MyPlane* MyGet (int nom) { return (MyPlane*)GetAt(nom); }
	int ExistsPlane (MyPlane* plane);
		//   ,  -1,   "",  -2,   
	int PlaneByPoint (int mPoint);
		//    ,  -2,   
	friend ostream& operator<< (ostream& os, MyArrayPlane& arrplane);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyArrayPlane16 - :     16

const int maxPlanes = 5000;

class MyArrayPlane16 {
private:
	int mDim, kolPlanes;
	bool Array [maxPlanes] [65536];
public:
	MyArrayPlane16 (int mDim);
	void AddPlane (MyPlane* plane);	//     
};


#endif
