
#include "StdAfx.h"
#include "Utily.h"
#include <windows.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Obmen (int& n1, int& n2) {
	int n = n1;
	n1 = n2;
	n2 = n;
}

void Obmen (double& r1, double& r2) {
	double r = r1;
	r1 = r2;
	r2 = r;
}

bool Nulla (double r, double eps) { return r>=0.0 ? r<=eps : r>=-eps; }

bool Nulla (double r) { return Nulla(r,1.0e-6); }

double GetInfty () { return 1.0e8; }

double GetMinusInfty () { return -GetInfty(); }

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void BoundsInt (int& n, int nMin, int nMax) {
	if (n<=nMin) n = nMin;
	else if (n>=nMax) n = nMax;
}

void Bounds (double& r, double rMin, double rMax) {
	if (r<=rMin) r = rMin;
	else if (r>=rMax) r = rMax;
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool MyInclude (unsigned char c1, unsigned char c2) {
	return c2==2 || c1==c2;
}

int Sosed (int mPoint, int nDim, int nCoord) {
	/*
	int mMod = mPoint % 2;
	int mDiv = mPoint / 2;
	if (nCoord==0) return (2 * mDiv) + (1 - mMod);
	int nRec = Sosed(mDiv,nDim-1,nCoord-1);
	return 2 * nRec + mMod;
	*/
	return mPoint^(1<<nCoord);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void MyError (int nCode) {
	CString str;
	if		(nCode==1)	str = "Popitka obrabativat' ploskosti raznih razmernostey";
	else if	(nCode==2)	str = "Slishkom bol'shaya razmernost' ploskosti";
	else if	(nCode==3)	str = "V kachestve vhoda chitivaetsya chyort znaet chto";
	else if	(nCode==4)	str = "Obraschenie k slishkom bol'shoy koordinate";
	else if	(nCode==5)	str = "Ne otkrivaetsya fayl";
	else if	(nCode==6)	str = "Net tochek v kube, kotoriy dolzhen bil bit' nepustim";
	else if	(nCode==7)	str = "Nechyotnoe znachenie dvoynoy stoimosti";
	else if	(nCode==8)	str = "Popitka obrabativat' kubi raznih razmernostey";
	else if	(nCode==9)	str = "Net neobrabotannih 1 (hotya ozhidalos')";
	else if	(nCode==10)	str = "Neponyatno pochemu ne smogli postroit' ploskost'";
	else if	(nCode==11)	str = "Nadenniy # ploskosti ne raven ozhidavshemusya";
	else if	(nCode==12)	str = "Starya oshibka s 2 variantami InsertAt()";
	else if	(nCode==13)	str = "Nesovpadayuschee chislo 1 u odnoy i toy zhe DNF";
	else if	(nCode==14)	str = "Tipa konec raboti";
	else if	(nCode==15)	str = "Nashli `ob'emlyuschuyu' ploskost'";
	else if	(nCode==16)	str = "Kakaya-to problema s greedy-algoritmom postroeniya ploskosti";
	else if	(nCode==17)	str = "Neozhidanno ne nashli podzadachu";
	else if	(nCode==18)	str = "Delaem pravuyu podzadachu s uzhe suschestvuyuschey ploskost'yu";
	else if	(nCode==19)	str = "Perepolnenie (prosteyshego) massiva ploskostey";
	else if	(nCode==20)	str = "Pitaemsya rasshirit' ploskost' na koordinatu uzhe ravnuyu 2";
	else if	(nCode==21)	str = "Plohoe vichislenie sosedey";
	else				str = "An error...";
	cout << str << endl;
	exit(1);
}
